﻿/// <reference path="../libs/angular/angular.js" />
/// <reference path="../libs/jquery/jquery-1.10.1.js" />
'use strict';

/* Controllers */

var cont = angular.module('mobilize')
.controller('list', ['$scope', '$poi', '$routeParams', '$timeout', '$rootScope',
function ($scope, $poi, $routeParams, $timeout, $rootScope) {

        $scope.page = $scope.getPage($routeParams.content);

        $scope.content = "/app/partials/content/" + $scope.page.key + ".html";

        $scope.scopeTitle = $scope.page.title;
        $scope.poitype = $scope.page.poiKey;

        //$scope.location = "";

        $scope.$watch('poitype', function () {
            if ($scope.poitype)
                $scope.poiEnabled = true;
            else
                $scope.poiEnabled = false;
            $scope.search();
        });

        $scope.$parent.$parent.$watch('location', function (v) {
            $scope.location = v;
            $scope.search();
        });

        $scope.pois = [];

        $scope.loading = true;

        $scope.selectedPoi = {};
        var srchLoop = 0;
        $scope.search = function () {
            $scope.loading = true;
            if ($scope.poitype) {
                srchLoop++;
                $poi.search($scope.poitype, $scope.location)
                    .then(function (data) {
                        srchLoop = 0;

                        while ($scope.pois.length > 0)
                            $scope.pois.pop();
                        
                        var selectedFixed = false;
                        for (var i in data.poi) {
                            var poi = data.poi[i];
                            if ($scope.selectedPoi.id == poi.id) {
                                $scope.selectedPoi = poi;
                                selectedFixed = true;
                            }
                            $scope.pois.push(poi);
                        }
                        if (!selectedFixed)
                            $scope.selectedPoi = {};
                        $scope.loading = false;
                    },
                    function (error) {
                        if (srchLoop < 10)
                            $scope.search();
                        else {
                            alert('failing to search');
                            $scope.poiEnabled = false;
                        }
                    });
            }
        };
        $scope.search();
}])