﻿/// <reference path="../libs/angular/angular.js" />
/// <reference path="../libs/jquery/jquery-1.10.1.js" />
'use strict';

/* Controllers */

var cont = angular.module('mobilize')
.controller('map', ['$scope', '$poi', '$routeParams', '$timeout', '$rootScope', '$location',
function ($scope, $poi, $routeParams, $timeout, $rootScope, $location) {

        $scope.page = $scope.getPage($routeParams.content);

        $scope.content = "/app/partials/content/" + $scope.page.key + ".html";

        $scope.scopeTitle = $scope.page.title;
        $scope.poitype = $scope.page.poiKey;


        $scope.$parent.$parent.$watch('location', function (v) {
            $scope.location = v;
            $scope.search();
        });


        $scope.loading = true;

        $scope.mapmarkers = [];
        $scope.mapcenter = {};
        
        var currentOpen = {};
        $scope.$on('leafletDirectiveMarkersClick', function (e, idx) {
            var poi = $scope.mapmarkers[idx];
            if (poi == currentOpen) {
                var url = '/content/' + $scope.page.key + '/poi/' + $scope.mapmarkers[idx].poi.id;
                $location.path(url);
                $scope.$apply();
            } else {
                currentOpen = poi;
            }
           // e.preventDefault();
            

        });

        var srchLoop = 0;
        $scope.search = function () {
            $scope.loading = true;
            if ($scope.poitype) {
                srchLoop++;
                $poi.search($scope.poitype, $scope.location)
                    .then(function (data) {
                        srchLoop = 0;
                        $scope.mapcenter = {
                            lat: data.poi[0].lat,
                            lng: data.poi[0].lon,
                            zoom: 12
                        };
                        while ($scope.mapmarkers.length > 0)
                            $scope.mapmarkers.pop();

                        for (var i in data.poi) {
                            var poi = data.poi[i];
                            
                            $scope.mapmarkers.push({
                                lat: poi.lat,
                                lng: poi.lon,
                                message: poi.name,
                                draggable: false,
                                poi: poi
                            });
                            $scope.mapcenter.lat = (poi.lat + $scope.mapcenter.lat) / 2;
                            $scope.mapcenter.lng = (poi.lon + $scope.mapcenter.lng) / 2;
                        }

                        $scope.loading = false;
                    },
                    function (error) {
                        if (srchLoop < 10)
                            $scope.search();
                        else {
                            alert('failing to search');
                            $scope.poiEnabled = false;
                        }
                    });
            }
        };
        $scope.search();
}])