﻿/// <reference path="../libs/angular/angular.js" />
/// <reference path="../libs/jquery/jquery-1.10.1.js" />
'use strict';

/* Controllers */

var cont = angular.module('mobilize')
.controller('page', ['$scope', '$poi', '$routeParams', '$timeout', '$rootScope',
    function ($scope, $poi, $routeParams, $timeout, $rootScope) {

        $scope.page = $scope.getPage($routeParams.content);
        $scope.backurl = "/";
        if($scope.page.$parent)
            $scope.backurl = "/content/"+$scope.page.$parent.$key;
        $scope.scopeTitle = $scope.page.title;
        $scope.poitype = $scope.page.poiKey;

        $scope.content = "./app/partials/content/" + $scope.page.$path + ".html";
        $scope.servicelocation = "./app/partials/services.html";
        $scope.maplocation = "./app/partials/map.html";
        $scope.listlocation = "./app/partials/list.html";


        $scope.searchOpen = false;
        $scope.box_location = $scope.$parent.location;

        $scope.$parent.$watch("location", function (v) {
            $scope.box_location = v;
        });

        $scope.openSeachBox = function () {
            if ($scope.searchOpen) {
                $scope.box_location = $scope.$parent.location;
                $scope.searchOpen = false;
            } else {
                $scope.searchOpen = true;
            }
        };
        $scope.search = function () {
            $scope.searchOpen = false;
            $scope.$parent.location = $scope.box_location;
        }

        $scope.poiEnabled = false;
        $scope.$watch('poitype', function () {
            if ($scope.poitype)
                $scope.poiEnabled = true;
            else
                $scope.poiEnabled = false;
        });


    } ])