﻿/// <reference path="../libs/angular/angular.js" />
/// <reference path="../libs/jquery/jquery-1.10.1.js" />
'use strict';

/* Controllers */

var cont = angular.module('mobilize')
.controller('poi', ['$scope', '$poi', '$routeParams', '$timeout', '$rootScope',
function ($scope, $poi, $routeParams, $timeout, $rootScope) {

    $scope.loading = true;
    $scope.page = $scope.getPage($routeParams.content);
    $scope.poi = { id : $routeParams.id };
    $scope.mapmarkers = [];
    var srchLoop = 0;
    var load = function () {
        $scope.loading = true;
        if ($scope.page.poiKey) {
            srchLoop++;
            $poi.search($scope.page.poiKey, $scope.location)
                .then(function (data) {
                    srchLoop = 0;

                    for (var i in data.poi) {
                        var poi = data.poi[i];
                        if (poi.id == $scope.poi.id) {
                            $scope.poi = poi;
                            
                            $scope.mapmarkers.push({
                                lat: poi.lat,
                                lng: poi.lon,
                                draggable: false,
                                focus: true,
                                poi: poi,
                                message: poi.name
                            });
                            $scope.mapcenter = {
                                lat: poi.lat,
                                lng: poi.lon,
                                zoom: 15
                            };

                            break;
                        }
                    }
                    $scope.loading = false;
                },
                function (error) {
                    if (srchLoop < 10)
                        load();
                    else {
                        alert('failing to search');
                        $scope.poiEnabled = false;
                    }
                });
        }
    };
    load();
    
}])