﻿/// <reference path="../libs/angular/angular.js" />
'use strict';

/* Controllers */

////this is where all the inital page metadata lives
var pages = [
    {
        icon: "health_advice",
        title: "Health advice",
        key: "Health_Advice",
        pages: [{
            title: "Alcohol",
            key: "Alcohol"
        },
        {
            title: "Exercise",
            key: "Exercise"
        },
        {
            title: "Healthy eating",
            key: "Healthy_eating"
        },
        {
            title: "Sexual health",
            key: "Sexual_health",
            poiKey:'Nots-C-Card-Sex-health'
        },
        {
            title: "Smoking",
            key: "Smoking"
        },
        {
            title: "NHS Health Checks",
            key: "NHS_Health_Checks"
        }
        ]
    }, 
    
    {
        icon: "pharmacy",
        title: "Pharmacy",
        poiKey: "Nots-pharmacies",
        key: "Pharmacy"
    },
    {
        icon: "GPs",
        title: "GPs",
        poiKey: "Nots-gps",
        key: "GPs"
    },


    {
        icon: "phone",
        title: "Call 111 ",
        key: "Call_111"
    },

    {
        icon: "person_walking",
        title: "Walk-in centres",
        poiKey: "Nots-walkin-centre",
        key: "Walk-in"
    },
    {
        icon: "emergencies",
        title: "Emergencies",
        poiKey: "Nots-AE",
        key: "Emergencies"
    },

    {
        icon: "envelope",
        title: "Contact us",
        key: "Contact_us"
    },

    {
        icon: "NHSChoices",
        title: "NHS Choices",
        key: "NHSChoices"
    },
       
    {
        icon: "web",
        title: "Our website",
        key: "Website"
    }
];

    var cont = angular.module('mobilize')
.controller('root', ['$scope', '$rootScope', '$location', '$timeout', '$poi', function ($scope, $rootScope, $location, $timeout, $poi) {
    $poi.setup({
        key: 'nottingham-city-nhs'
    });

    $scope.isTablet = $location.$$search.tablet == 'true' || (/ipad|android 3.0|xoom|sch-i800|playbook|tablet|kindle/i.test(navigator.userAgent.toLowerCase()));

    $scope.mainMenuVisible = false;
    $scope.popupShown = false;
    $scope.pages = [];
    $scope.pagesLookup = {};
    $scope.loadingScreenVisible = false;
    //$timeout(function () {
    //    $scope.loadingScreenVisible = false;
    //}, 1000);
    var safeApply = function (scope, fn) {
        (scope.$$phase || scope.$root.$$phase) ? fn() : scope.$apply(fn);
    };
    var updateOrientation = function () {
        if (window.innerWidth / window.innerHeight < 1) {
            $scope.orientation = "portrate"
        } else {
            $scope.orientation = "landscape"
        }
    };
    $(window).on("resize", function (event) {
        safeApply($scope, updateOrientation);
    });
    updateOrientation();

    // is this an IPad ?
var isiPad = (navigator.userAgent.match(/iPad/i) != null);

// is this an iPhone ?
var isiPhone = (navigator.userAgent.match(/iPhone/i) != null);

// is this an iPod ?
var isiPod = (navigator.userAgent.match(/iPod/i) != null);


    $scope.getPage = function (key) {
        return $scope.pagesLookup[key] || { key: key };
    }

    var loadPages = function (parent, pages) {

        for (var i in pages) {
            var p = pages[i];
            p.view = 'content';

            p.$parent = parent;

            if (!parent) {
                $scope.pages.push(p);
                p.$key = p.key
                p.$path = p.key
            }
            else {
                p.$key = parent.$key + "~" + p.key;
                p.$path = parent.$path + "/" + p.key
            }

            $scope.pagesLookup[p.$key] = p;

            if (p.pages) {
                loadPages(p, p.pages)
            }
        }
    }

    loadPages(null, pages);

    function resetContentViews() {
        //the currently selectd tab is stored on the page object for backlinks to work,
        //reset them when we hit the homepage so that they will fall back to content 
        for (var i in $scope.pages)
            $scope.pages[i].view = 'content';
    }

    //$scope.path = $location.path();
    $rootScope.$on('$routeChangeStart', function (event, currRoute, prevRoute) {
        if ($location.path() == "/") {
            $scope.mainMenuVisible = true;
            resetContentViews();
        } else {
            $scope.mainMenuVisible = false;
        }
        //$scope.path = $location.path();
    });
} ])