﻿/// <reference path="../libs/angular/angular.js" />

angular.module('mobilize.services')
.factory('$geoLocation', ['$q', '$rootScope', function ($q, $rootScope) {

    var lastLookupDate = 0;
    var lastPromise = null

    var lastLocation = null;
    var relookAfter = 0;
    var looking = false;

    return {
        location: function () {
            var d = $q.defer();
            var now = new Date();
            if (lastLocation == null || relookAfter < now) {
                relookAfter = new Date();
                relookAfter.setMinutes(relookAfter.getMinutes() + 1);

                if (looking) {
                    var sendResult = function () {
                        if (!looking) {
                            d.resolve(lastLocation);
                        } else {
                            setTimeout(sendResult, 100);
                        }
                    }
                    sendResult();

                } else {
                    looking = true;
                    try {
                        if (navigator.geolocation) {
                            navigator.geolocation.getCurrentPosition(
                            function (position) {
                                lastLocation = position.coords;
                                looking = false;
                                $rootScope.$apply(function () {
                                    d.resolve(position.coords);
                                });
                            },
                            function (error) {
                                d.reject(error);
                            }
                        );
                        }
                        else {
                            d.reject('location services not allowed');
                        }
                    }
                    catch (err) {
                        d.reject(err);
                    }
                }
            } else {
                d.resolve(lastLocation);
            }
            return d.promise;
        }
    };
} ]);


